<template>
  <q-page>
    <q-table
      ref="tableRef"
      title="Inscriptos"
      :dense="true"
      :rows="dataSet"
      :columns="columnas"
      row-key="uuid"
      wrap-cells
      v-model:pagination="EventoInscriptosStore.filtros"
      :loading="loading"
      binary-state-sort
      @request="onPaginar"
    >
      <!--------------------------------------
            loading
          ---------------------------------------->
      <template v-slot:loading>
        <Loading showing />
      </template>

      <!--------------------------------------
            Btn Exportacion
          ---------------------------------------->
      <template v-slot:top-left>
        <div class="q-col-gutter-md row">
          <q-input
            dense
            placeholder="Buscar ..."
            v-model="EventoInscriptosStore.filtros.query"
            debounce="300"
          >
            <template v-slot:append>
              <q-icon name="search" />
            </template>
          </q-input>

          <q-select
            v-model="EventoInscriptosStore.filtros.tipo"
            style="min-width: 150px"
            dense
            use-chips
            emit-value
            stack-label
            map-options
            :options="[
              { label: 'Inscriptos', value: 'altas' },
              { label: 'Bajas', value: 'bajas' },
            ]"
            label="Estado"
          />

          <q-select
            v-model="EventoInscriptosStore.filtros.categoria"
            style="min-width: 150px"
            dense
            use-chips
            emit-value
            stack-label
            map-options
            :options="[
              { label: 'Adultos', value: 'A' },
              { label: 'Beneficiarios', value: 'B' },
            ]"
            label="Tipo"
          />

          <!-- ESTE COMBO SOLO SE TIENE QUE MOESTRAR EN LOS EVENTOS DE PROGRAMA -->
          <SelectRama
            v-if="evento.rama_obligatorio"
            :filled="false"
            v-model="EventoInscriptosStore.filtros.rama"
            label="Rama"
          />

          <q-select
            v-model="EventoInscriptosStore.filtros.mizona"
            style="min-width: 150px"
            dense
            use-chips
            emit-value
            stack-label
            map-options
            :options="[
              { label: 'Solo Mis Organismos', value: 'S' },
              { label: 'Otros Organismos', value: 'N' },
            ]"
            label="Zona"
          />

          <q-select
            v-model="EventoInscriptosStore.filtros.pago"
            style="min-width: 150px"
            dense
            use-chips
            emit-value
            stack-label
            map-options
            :options="[
              { label: 'Pagado', value: 'S' },
              { label: 'Pendiente', value: 'N' },
            ]"
            label="Pago"
          />

          <q-select
            v-model="EventoInscriptosStore.filtros.dieta"
            style="min-width: 150px"
            dense
            multiple
            use-chips
            emit-value
            stack-label
            map-options
            :options="[
              { label: 'Con Dieta', value: 'S' },
              { label: 'Sin Dieta', value: 'N' },
            ]"
            label="Dieta"
          />

          <q-btn color="green" flat label="Filtrar" @click="onRequest" />
        </div>
        <!-- Filtrasr
         tipo => Adultos y Beneficarios.
         rama => en eventos de programa, que permista filtrar la rama en que se anoto
         Otra zona / otro distrito
         por dieta
         -->
      </template>
      <template v-slot:no-data>Sin Inscriptos</template>
      <template v-slot:top-right>
        <div class="q-pa-sm">
          <q-btn-group outline class="q-gutter-sm">
            <Download
              url="/api/eventos/inscriptos"
              :parametros="EventoInscriptosStore.filtros"
              :nombre="
                evento.organismo + ' - ' + evento.evento + ' - Filtrado.xlsx'
              "
              color="amber"
            >
              Exportar Filtrado
            </Download>

            <Download
              url="/api/eventos/inscriptos"
              :parametros="{
                tipo: 'altas', // siempre traigo a los inscriptos
                evento_uuid: evento.uuid,
              }"
              :nombre="
                evento.organismo + ' - ' + evento.evento + ' - Completo.xlsx'
              "
            >
              Exportar Full
            </Download>
          </q-btn-group>
        </div>
      </template>

      <!--------------------------------------
            Columnas
          ---------------------------------------->

      <template v-slot:body-cell-datos="props">
        <q-td :props="props">
          <PersonaDetalle :persona="props.row.persona"></PersonaDetalle>
        </q-td>
      </template>

      <template v-slot:body-cell-rama="props" v-if="evento.rama_obligatorio">
        <q-td :props="props">
          <ItemRama :rama="props.row.rama" />
        </q-td>
      </template>

      <template v-slot:body-cell-funcion="props">
        <q-td :props="props">
          <PersonasFunciones :funciones="props.row.persona.funciones" />
        </q-td>
      </template>

      <template v-slot:body-cell-pago="props">
        <q-td :props="props">
          <q-btn
            v-if="props.row.recibo"
            dark
            size="sm"
            outline
            rounded
            icon="attach_money"
            color="green"
            label="Pagado"
            :to="'/finanzas/recibos/detalle/' + props.row.recibo"
          />
        </q-td>
      </template>

      <template v-slot:body-cell-dieta="props">
        <q-td :props="props">
          <template v-if="props.row.persona.datos">
            {{ props.row.persona.datos.alimentacion_especial_detalle }}
          </template>
        </q-td>
      </template>

      <template v-slot:body-cell-opciones="props">
        <q-td :props="props">
          <div class="q-pa-md q-gutter-sm">
            <!-- Migrarlo a un componente, que acepte el objeto persona o el uuid , si recibe persona muesta un tooltip con algo de info basica -->
            <q-btn
              color="blue"
              size="sm"
              flat
              round
              icon="fas os-accion-scout-perfil"
              :to="'/membresia/personas/perfil/' + props.row.persona.uuid"
            >
              <q-tooltip>
                Ver perfil de {{ props.row.persona.apellidoynombre }}
              </q-tooltip>
            </q-btn>
            <template v-if="evento.soy_propietario && !evento.borrado">
              <q-btn
                v-if="evento.rama_obligatorio"
                color="green"
                size="sm"
                flat
                round
                icon="edit"
                @click="ramaCorregir(props.row)"
              >
                <q-tooltip>
                  Cambiar rama de cursada
                  {{ props.row.persona.apellidoynombre }}
                </q-tooltip>
              </q-btn>

              <q-btn
                v-if="EventoInscriptosStore.filtros.tipo === 'altas'"
                color="red"
                size="sm"
                flat
                round
                icon="person_remove"
                @click="darDeBajaParticipante(props.row.uuid)"
              >
                <q-tooltip>
                  dar de baja a {{ props.row.persona.apellidoynombre }}
                </q-tooltip>
              </q-btn>
              <q-btn
                v-if="EventoInscriptosStore.filtros.tipo !== 'altas'"
                color="green"
                size="sm"
                flat
                round
                icon="person_add_alt"
                @click="darDeAltaParticipante(props.row.persona.uuid)"
              >
                <q-tooltip>
                  dar de alta a {{ props.row.persona.apellidoynombre }}
                </q-tooltip>
              </q-btn>
            </template>
          </div>
        </q-td>
      </template>
    </q-table>
    <DialogCorregirRamaPartial
      v-if="ramaShowDialog"
      :participante="ramaCorregirInscripto"
      :show="ramaShowDialog"
      @close="ramaCerrarDialog"
    />
  </q-page>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref } from 'vue';
import { useQuasar, QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import { useEventosInscriptosStore } from 'src/stores/eventos/inscriptos';
import { useRoute } from 'vue-router';
import PersonaDetalle from 'components/Personas/Detalle.vue';
import PersonasFunciones from 'components/Personas/Funciones.vue';
import SelectRama from 'components/Form/selectRama.vue';
import DialogCorregirRamaPartial from './_DialogCorregirRamaPartial.vue';
import { EventosInscriptosInterface } from 'src/interfaces/EventosInterface';
import Download from 'src/components/Util/Download.vue';
import Loading from 'src/components/Loading.vue';
import ItemRama from 'components/Util/ItemRama.vue';

// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'datos', label: 'Datos', field: 'datos', align: 'left' },
  {
    name: 'funcion',
    label: 'Funciones',
    field: 'funcion',
    align: 'left',
  },
  { name: 'pago', label: 'Pago', field: 'pago', align: 'left' },

  {
    name: 'dieta',
    label: 'Dieta',
    field: 'dieta',
    align: 'center',
    style: 'width: 200px',
  },
  { name: 'opciones', label: 'Opciones', field: 'opciones', align: 'left' },
];

export default defineComponent({
  name: 'ListadoInscriptosPartial',
  props: {
    evento: {
      type: Object,
      required: true,
    },
  },

  components: {
    Loading,
    Download,
    PersonaDetalle,
    PersonasFunciones,
    SelectRama,
    DialogCorregirRamaPartial,
    ItemRama,
  },

  setup(props) {
    const tableRef = ref();

    const loading = ref(true);
    const EventoInscriptosStore = useEventosInscriptosStore();
    const $q = useQuasar();
    const route = useRoute();
    const uuid = String(route.params.uuid);

    if (columnas[1].name != 'rama') {
      columnas.splice(1, 0);
    }

    if (props.evento.rama_obligatorio) {
      /// arr.splice(index, 0, item);
      columnas.splice(1, 0, {
        name: 'rama',
        label: 'Rama Cursa',
        field: 'rama',
        align: 'left',
      });
    }

    onMounted(() => {
      EventoInscriptosStore.resetFiltros(); // esto lo hago para que no se tome los datos guardados de otro evento detalle
      EventoInscriptosStore.filtros.evento_uuid = uuid;
      // get initial data from server (1st page)
      tableRef.value.requestServerInteraction();
    });

    ////////////////////////////////////////////////////////////////////////////////
    //            GESTION DE PAGINADO Y GESTION DE DATOS
    ////////////////////////////////////////////////////////////////////////////////
    /*********************************************
     *  Metodo onPaginar
     *  Gestiona la configuracion del paginado.
     */
    function onPaginar(props: QTableProps) {
      EventoInscriptosStore.setPaginar(props);
      onRequest();
    }

    function onFiltrar() {
      EventoInscriptosStore.filtroActivado = true;
      EventoInscriptosStore.filtros.page = 1; // siempre que vuelvo a filtra, vuelvo a la pagina 1.
      onRequest();
    }

    /*********************************************
     *  Metoto onRequest
     *  encargado de obtener los datos desde la API
     */
    const dataSet = ref<EventosInscriptosInterface[]>();
    function onRequest() {
      loading.value = true;
      api
        .get('/api/eventos/inscriptos', {
          params: EventoInscriptosStore.parametros,
        })
        .then((response: AxiosResponse) => {
          EventoInscriptosStore.setRowTotal(response.data.count); // Actializo la cantidas de row, por si cambio
          dataSet.value = response.data.data;
          loading.value = false;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    /*********************************************
     *  Metoto resetFiltros
     *  Reinilizo los Filtros
     */
    function onResetFiltros() {
      EventoInscriptosStore.resetFiltros();
      // getCombosEquipos();
      // Recargo la info de la pagina !
      onRequest();
    }

    /*********************************************
     *  Combo cambio de rama
     */
    const ramaShowDialog = ref(false);
    const ramaCorregirInscripto = ref();
    function ramaCorregir(inscripto: EventosInscriptosInterface) {
      ramaShowDialog.value = true;
      ramaCorregirInscripto.value = inscripto;
    }
    function ramaCerrarDialog() {
      ramaShowDialog.value = false;
      ramaCorregirInscripto.value = {};
      onRequest();
    }
    /*********************************************/

    function darDeBajaParticipante(uuid: string) {
      $q.dialog({
        title: 'Generacion de baja',
        message: 'Esta seguro de generar la baja ?',
        persistent: true,
        ok: {
          color: 'red',
          label: 'Dar de Baja',
        },
        cancel: {
          color: 'green',
          label: 'Cancelar !',
        },
      })
        .onOk(() => {
          loading.value = true;

          api
            .delete('/api/eventos/inscriptos', {
              params: { inscripto_uuid: uuid },
            })
            .finally(() => {
              onRequest();
            });
        })
        .onCancel(() => {
          $q.notify({
            message: 'Accion cancelada',
            color: 'red',
            position: 'top',
          });
        });
    }
    function darDeAltaParticipante(personaUuid: string) {
      loading.value = true;

      api
        .post('/api/eventos/inscriptos', {
          persona_uuid: personaUuid,
          evento_uuid: uuid,
        })
        .finally(() => {
          onRequest();
        });
    }

    return {
      tableRef,
      columnas,
      dataSet,
      EventoInscriptosStore,
      onRequest,
      onPaginar,
      onResetFiltros,
      onFiltrar,
      loading,
      darDeBajaParticipante,
      darDeAltaParticipante,

      ramaCorregir,
      ramaCerrarDialog,
      ramaShowDialog,
      ramaCorregirInscripto,
    };
  },
});
</script>
